searchNodes=[{"doc":"A formatter for JSON logs.","ref":"Medea.Formatter.html","title":"Medea.Formatter","type":"module"},{"doc":"Format messages into structured JSON logs.","ref":"Medea.Formatter.html#format/4","title":"Medea.Formatter.format/4","type":"function"},{"doc":"","ref":"Medea.Formatter.html#t:time/0","title":"Medea.Formatter.time/0","type":"type"},{"doc":"Translates structured log &quot;reports&quot; into encoded JSON iodata.","ref":"Medea.Translator.html","title":"Medea.Translator","type":"module"},{"doc":"Translate a report into encoded JSON iodata or fall through to the default translator.","ref":"Medea.Translator.html#translate/4","title":"Medea.Translator.translate/4","type":"function"},{"doc":"","ref":"Medea.Translator.html#t:kind/0","title":"Medea.Translator.kind/0","type":"type"},{"doc":"","ref":"Medea.Translator.html#t:level/0","title":"Medea.Translator.level/0","type":"type"},{"doc":"","ref":"Medea.Translator.html#t:report/0","title":"Medea.Translator.report/0","type":"type"},{"doc":"","ref":"Medea.Translator.html#t:result/0","title":"Medea.Translator.result/0","type":"type"},{"doc":"Sorceress, wife to Jason, tiny logger of nicely formatted structured messages. Medea is a tiny package that provides a formatter and a translator to preserve structured logs. For example, here is the difference between structured logging with inspection and the structured JSON we'd expect: # Inspected &quot;message&quot; :&quot;%{args: %{id: 1, on: false}}&quot; # Structured &quot;message&quot; : { &quot;args&quot; : { &quot;id&quot; : 1 , &quot;on&quot; :false } } The former contains an inspected Elixir map, while the latter is easily parsable as JSON. With Medea, all terms are safely escaped and converted to JSON printable values. That means structured logging like this: Logger . info ( event : %{ name : :stuff , safe : false } , user : % User { id : 123 } ) Outputs nested JSON like this: { &quot;level&quot; :&quot;info&quot; , &quot;message&quot; : { &quot;event&quot; : { &quot;name&quot; :&quot;stuff&quot; , &quot;safe&quot; :false } , &quot;user&quot; : { &quot;id&quot; : 123 } } , &quot;metadata&quot; : [ ] , &quot;time&quot; :&quot;2022-10-11T15:07:33.000&quot; }","ref":"readme.html","title":"Medea","type":"extras"},{"doc":"The package can be installed by adding medea to your list of dependencies in mix.exs : def deps do [ { :medea , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"Medea - Installation","type":"extras"},{"doc":"Medea has two components: Medea.Formatter and Medea.Translator . For complete functionality, both components must be configured. First, configure the logger backend with the formatter: config :logger , :console , format : { Medea.Formatter , :format } , metadata : [ :request_id ] Next, enable the translator at the top of your applications start/2 function: def start ( _type , _args ) do Logger . add_translator ( { Medea.Translator , :translate } ) children = [ # whichever children you have ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end","ref":"readme.html#usage","title":"Medea - Usage","type":"extras"},{"doc":"If you're using Ecto, you should disable the default logger: config :my_app , MyApp.Repo , log : false Now replace it with a simple telemetry based instrumenter that logs structured queries with metadata: defmodule MyApp.EctoLogger do @moduledoc false require Logger def handle_event ( _event , measure , %{ query : query , repo : repo } , level ) do query_meta = Map . take ( measure , ~w(idle_time queue_time query_time decode_time total_time)a ) Logger . log ( level , query , repo : inspect ( repo ) , query : query_meta ) end end Attach the logger with telemetry: :telemetry . attach ( &quot;ecto-logger&quot; , [ :my_app , :repo , :query ] , &amp; MyApp.EctoLogger . handle_event / 4 , :info ) Additional documentation can be found at https://hexdocs.pm/medea .","ref":"readme.html#logging-with-ecto","title":"Medea - Logging With Ecto","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Ensure full keyword list before encoding as map This fixes situations where there are erlang-style option lists with both atoms and tuples, e.g. [{Mod, []}, :enabled]","ref":"changelog.html#v0-1-1-2022-12-06","title":"Changelog - v0.1.1 — 2022-12-06","type":"extras"},{"doc":"Initial release with a translator and formatter for structured JSON logs.","ref":"changelog.html#v0-1-0-2022-10-10","title":"Changelog - v0.1.0 — 2022-10-10","type":"extras"}]